#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cctype>

#include <iostream>
#include <sstream>
#include <string>

#include <vector>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <algorithm>
using namespace std;


#define FOR(i,n) for (int i=0; i<(n); i++)
#define FORTO(i,a,b) for (int i=(a); i<=(b); i++)
#define FORD(i,n) for (int i = (n)-1; i>=0; i--)


#define DEBUG(x) cout << '>' << #x << ':' << x << endl;
#define SIZE(x) int(x.size())

typedef pair<int,int> PII;
typedef long long ll;

struct Point {
	double x, y;
	Point(double _x = 0, double _y = 0) {
		x = _x, y = _y;
	}
};

typedef pair<Point,Point> PP;
typedef pair<Point,Point> Rect;

double D = 0.0;

inline double sqr(double x) {
	return x*x;
}

const double eps = 1e-6;

bool doubleEqual(double a, double b) {
	return abs(a-b) < eps;
}

bool PointEqual(Point a, Point b) {
	return doubleEqual(a.x,b.x) && doubleEqual(a.y,b.y);
}

double pointDist(Point a, Point b) {
	double dx = a.x-b.x;
	double dy = a.y-b.y;
	return sqrt(dx*dx + dy*dy);
}

bool circlesInt(Point a, Point b, PP &res) {
	double e = pointDist(a,b); 
	if (doubleEqual(e,0) || e > 2*D)
		return false;
	double s = (D + D + e)/2.0;
	double h = 2.0 * sqrt(s*sqr(s-D)*(s-e)) / e;
	DEBUG(h);
	Point u(h*(b.y-a.y),h*(a.x-b.x));
	Point c((a.x+b.x)/2,(a.y+b.y)/2);
	DEBUG(u.x);
	DEBUG(u.y);
	res = PP(Point(c.x+u.x,c.y+u.y),Point(c.x-u.x,c.y-u.y));
	return true;
}

bool circleLineXInt(Point s, double x, PP &res) {
	double D = sqr(D) - sqr(s.x-x);
	if (D < 0.0)  return false;
	res = PP(Point(x,s.y-sqrt(D)),Point(x,s.y+sqrt(D)));
	return true;
}

bool circleLineYInt(Point s, double y, PP &res) {
	double D = sqr(D) - sqr(s.y-y);
	if (D < 0.0)  return false;
	res = PP(Point(s.x-sqrt(D),y),Point(s.x+sqrt(D),y));
	return true;
}

inline bool isInRect(Rect rect, Point p) {
	Point &a = rect.first;
	Point &b = rect.second;
	return p.x >= a.x + eps && p.y >= a.y + eps && p.x <= b.x - eps && p.y <= b.y - eps;
}

inline bool isInCircle(Point p, Point s) {
	double dx = p.x - s.x;
	double dy = p.y - s.y;
	return dx * dx + dy * dy <= D*D - eps;
}

vector<double> linesX;
vector<double> linesY;

vector<Point> Circles;

vector<Rect> Forb;
Rect Boundary;

bool Test(Point &p) {
	if (!isInRect(Boundary,p))
		return false;
	
	FOR(i,SIZE(Forb))
		if (isInRect(Forb[i],p)) return false;
	
	FOR(i,SIZE(Circles))
		if (isInCircle(Circles[i],p)) return false;
	
	return true;
}

int main()
{
	D = 2;
	PP res;
	DEBUG(circlesInt(Point(0,0),Point(2,2),res));
	DEBUG(res.first.x);
	DEBUG(res.first.y);
	DEBUG(res.second.x);
	DEBUG(res.second.y);
	return 0;
	while (true) {
		int Rx, Ry, N;
		scanf("%lf %d %d %d", &D, &Rx, &Ry, &N);
		Boundary = Rect(Point(0.0),Point(Rx,Ry));
		
		linesX.clear();
		linesY.clear();
		Circles.clear();
		Forb.clear();
		
		linesX.push_back(0+2*eps);
		linesY.push_back(0+2*eps);
		linesX.push_back(Rx-2*eps);
		linesY.push_back(Ry-2*eps);
		
		FOR(i,N) {
			int x1, y1, x2, y2;
			scanf("%d %d %d %d", &x1, &y1, &x2, &y2);
			Circles.push_back(Point(x1,y1));
			Circles.push_back(Point(x1,y2));
			Circles.push_back(Point(x2,y1));
			Circles.push_back(Point(x2,y2));
		}
		
		
		
		
	}
	return 0;
}

